<?php
/*
 * +--------------------------------------------------------------------------+
 * | Copyright (c) 2010 Add This, LLC                                         |
 * +--------------------------------------------------------------------------+
 * | This program is free software; you can redistribute it and/or modify     |
 * | it under the terms of the GNU General Public License as published by     |
 * | the Free Software Foundation; either version 3 of the License, or        |
 * | (at your option) any later version.                                      |
 * |                                                                          |
 * | This program is distributed in the hope that it will be useful,          |
 * | but WITHOUT ANY WARRANTY; without even the implied warranty of           |
 * | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            |
 * | GNU General Public License for more details.                             |
 * |                                                                          |
 * | You should have received a copy of the GNU General Public License        |
 * | along with this program.  If not, see <http://www.gnu.org/licenses/>.    |
 * +--------------------------------------------------------------------------+
 */

	/**
	 *
	 * Creates AddThis sharing button and appends it to the user selected pages.
	 * Reads the user settings and creates the button accordingly.
	 *
	 * @author AddThis Team - Sol, Vipin
	 * @version 2.0.0
	 */

    // no direct access
	defined('_JEXEC') or die('Restricted access');

	appendAddThisWidgetJs($params);

	//Adds AddThis script to page
	appendAddThisScript($params);
	

	/**
	 * appendAddThisScript
	 *
	 * Reads button settings, creates corresponding AddThis button, reads AddThis configuration values,
	 * creates configuration object and Adds the resultant code to pages.
	 *
	 * @param object $params
	 * @return void
	 *
	 */
	function appendAddThisScript($params)
	{

    		//Creating div elements for AddThis
		$outputValue = " <div class='joomla_add_this'>";
		$outputValue .= "<!-- AddThis Button BEGIN -->" . PHP_EOL;

		//Creates addthis configuration script
		$outputValue .= "<script type='text/javascript'>\r\n";
		$outputValue .= "var addthis_product = 'jlp-2.0';\r\n";
		$outputValue .= "var addthis_config = {\r\n";
		$configParams = populateParams($params);
		$configValue = prepareConfigValues($configParams);
		
    	//Removing the last comma and end of line characters
    	if("" != trim($configValue))
		{
		  	$outputValue .= implode( ',', explode( ',', $configValue, -1 ));
		}
		$outputValue .= "\n}\n</script>". PHP_EOL;
    	
    	//Creates the button code depending on the button style chosen
        $buttonValue = getButtonSet($params);

		$outputValue .= $buttonValue;

		$outputValue .= "<!-- AddThis Button END -->". PHP_EOL;
		$outputValue .= "</div>";

        //Regular expression for finding the custom tag which disables AddThis button in the article.
        $switchregex = "#{addthis (on|off)}#s";

		if(class_exists("JFactory"))
		{
			//Gets frontpage
			$menu = JFactory::getApplication()->getMenu();
			//Sets the visibility of AddThis button in frontpage depending on user's settings
			if(($menu->getActive() == $menu->getDefault()) && ($params->get("show_frontpage") == false)) {
			  $hide_frontpage = true;
			  $outputValue = "";
			}
		}

		echo $outputValue;
	}

	/**
     * Toolbox
     *
     * Return which style is selected.
     *
     * @return string returns the toolbox html
     */
    function getButtonSet($params)
    {
		switch($params->get("button_style")){
        	
        	case 'style_1':
        		$buttonValue = '<div class="addthis_toolbox addthis_default_style ">
									<a class="addthis_button_preferred_1"></a>
									<a class="addthis_button_preferred_2"></a>
									<a class="addthis_button_preferred_3"></a>
									<a class="addthis_button_preferred_4"></a>
									<a class="addthis_button_compact"></a>
									<a class="addthis_counter addthis_bubble_style"></a>
								</div>';
        		break;
        		
        	case 'style_2':
        		$buttonValue = '<div class="addthis_toolbox addthis_default_style ">
									<a class="addthis_button_facebook_like" fb:like:layout="button_count"></a>
									<a class="addthis_button_tweet"></a>
									<a class="addthis_button_pinterest_pinit"></a>
									<a class="addthis_counter addthis_pill_style"></a>
								</div>';
				break;
			
        	case 'style_4':
        		$buttonValue = '<div class="addthis_toolbox addthis_default_style ">
									<a href="http://www.addthis.com/bookmark.php?v=250&amp;pubid=xa-4f0d95b663c861f6" class="addthis_button_compact">Share</a>
									<span class="addthis_separator">|</span>
									<a class="addthis_button_preferred_1"></a>
									<a class="addthis_button_preferred_2"></a>
									<a class="addthis_button_preferred_3"></a>
									<a class="addthis_button_preferred_4"></a>
								</div>';
        		break;
        		
			case 'style_5':
        		$buttonValue = '<div class="addthis_toolbox addthis_default_style ">
									<a href="http://www.addthis.com/bookmark.php?v=250&amp;pubid=xa-4f0d960e09c42ec4" class="addthis_button_compact">Share</a>
								</div>';
        		break;
        		
        	case 'style_6':
        		$buttonValue = '<div class="addthis_toolbox addthis_default_style ">
									<a class="addthis_counter addthis_pill_style"></a>
								</div>';
        		break;
        		
			case 'style_7':
        		$buttonValue = '<div class="addthis_toolbox addthis_default_style ">
									<a class="addthis_counter"></a>
								</div>';
        		break;
        		        		
			case 'style_8':
        		$buttonValue = '<a class="addthis_button" href="http://www.addthis.com/bookmark.php?v='.$params->get("menu_version").'">
									<img src="'.$params->get("custom_button_url").'" alt="Bookmark and Share" style="border:0"/>
								</a>';
        		break;
        					
        	default :
        		$buttonValue = '<div class="addthis_toolbox addthis_default_style addthis_32x32_style ">
									<a class="addthis_button_preferred_1"></a>
									<a class="addthis_button_preferred_2"></a>
									<a class="addthis_button_preferred_3"></a>
									<a class="addthis_button_preferred_4"></a>
									<a class="addthis_button_compact"></a>
									<a class="addthis_counter addthis_bubble_style"></a>
								</div> ';
        		break;        		
        }
        
        return $buttonValue;
    }
 

    /**
     * populateParams
     *
     * Gets the parameters and holds them as a collection
     *
     * @return Array of user selected AddThis configuration values
     */
     function populateParams($params)
     {
        $arrParams = array("profile_id", "button_style", "menu_version","custom_button_code",
        				   "addthis_brand", "addthis_header_color", "addthis_header_background", "addthis_services_compact",
        				   "addthis_services_exclude", "addthis_services_expanded", "addthis_services_custom", "addthis_offset_top",
        				   "addthis_offset_left", "addthis_hover_delay", "addthis_click", "addthis_hover_direction",
        				   "addthis_data_track_clickback", "addthis_language", "position", "show_frontpage", "toolbox_more_services_mode",
        				   "addthis_use_css", "addthis_ga_tracker");
        foreach ( $arrParams as $key => $value ) {
        	if($value == "profile_id")
				$arrParamValues[$value] = urlencode($params->get($value));
			else
				$arrParamValues[$value] = $params->get($value);	
		}
		return $arrParamValues;
     }

    /**
     * prepareConfigValues
     *
     * Prepares configuration values for AddThis button from user saved settings
     *
     * @return void
     */
    function prepareConfigValues($arrParamValues)
    {
    	$configValue = "";
		$arrConfigs = array("profile_id" => "pubid", "addthis_brand" => "ui_cobrand", "addthis_header_color" => "ui_header_color",
							"addthis_header_background" => "ui_header_background", "addthis_services_compact" => "services_compact",
							"addthis_services_exclude" => "services_exclude", "addthis_services_expanded" => "services_expanded",
							"addthis_services_custom" => "services_custom", "addthis_offset_top" => "ui_offset_top",
							"addthis_offset_left" => "ui_offset_left", "addthis_hover_delay" => "ui_delay", "addthis_click" => "ui_click",
							"addthis_hover_direction" => "ui_hover_direction", "addthis_data_track_clickback" => "data_track_clickback",
							"addthis_language" => "ui_language", "addthis_use_css" => "ui_use_css", "addthis_ga_tracker" => "data_ga_property");

    	foreach ( $arrConfigs as $key => $value ) {
		   if(in_array($value, array("pubid", "ui_cobrand", "ui_header_color", "ui_header_background", "services_compact", "services_exclude", "services_expanded", "ui_language", "data_ga_property")) && ($arrParamValues[$key] != ""))
		           $configValue .= $value . ":'" . $arrParamValues[$key] . "'," . PHP_EOL;
		   elseif(in_array($value, array("ui_offset_top", "ui_offset_left", "ui_delay", "ui_hover_direction", "services_custom")) && ($arrParamValues[$key] != ""))
				   $configValue .= $value . ":" . $arrParamValues[$key] . "," .  PHP_EOL;
		   elseif(in_array($value, array("ui_click", "data_track_clickback", "ui_use_css", )) && ($arrParamValues[$key] != ""))
				   $configValue .= "true" == $arrParamValues[$key]? $value . ":true," . PHP_EOL : (("ui_use_css" == $value || "data_track_clickback" == $value) ? $value . ":false," . PHP_EOL : "");
		}
		return $configValue;
    }

	/**
	 * Appending addthis main script to the head
	 *
	 * @return void
	 */
    function appendAddThisWidgetJs($params){
    	
    	$doc = JFactory::getDocument();
		$doc->addCustomTag('<script type="text/javascript" src="http://s7.addthis.com/js/'.$params->get("menu_version").'/addthis_widget.js"></script>');    	
    }  
